<template src="./template.html"></template>

<script lang="ts">
import _ from "lodash";
import { Component, Prop, Vue, Watch } from "nuxt-property-decorator";
import { apiErrorHandler } from "~/utils/apiHanlers";
import { getTimeZone, getUnixFrom, getUnixTo } from "~/utils/timeZone";
var momentz = require("moment-timezone");
var moment = require("moment");
@Component({
  components: {
    EmptyData: () => import("@/components/Utils/EmptyData/index.vue"),
  },
})
export default class ReportByDomainComponent extends Vue {
  @Prop()
  tab!: number;
  // dateArr = [
  //   moment().subtract(7, "days").format("YYYY-MM-DD"),
  //   moment().format("YYYY-MM-DD"),
  // ];
  get dateRangeText() {
    return this.dateArr.join("~");
  }

  config = {
    // page: 1,
    // limit: 25,
    search: "",
  };

  get dateArr() {
    return this.$store.state.setting?.dateArr || [];
  }

  set dateArr(value: string[]) {
    this.$store.commit("setting/setDateArr", value);
  }

  totalPage = 0;
  page = 1;
  loadingTable = false;
  dateStartPicker = false;
  dateEndPicker = false;
  dateStart = momentz().startOf("month").format("YYYY-MM-DD");
  dateEnd = moment().endOf("day").format("YYYY-MM-DD");
  listData: any = [];
  fav = true;
  menu = false;
  message = false;
  hints = true;
  selectedAll = [];
  selectedColumn = [
    {
      title: "UTM Campaign",
      value: 1,
    },
    {
      title: "UTM Source",
      value: 2,
    },
    {
      title: "UTM Medium",
      value: 3,
    },
    {
      title: "UTM Content",
      value: 4,
    },
    {
      title: "Conversion Rate %",
      value: 5,
    },
    {
      title: "View",
      value: 6,
    },
    {
      title: "AddtoCart",
      value: 7,
    },
    {
      title: "Checkout",
      value: 8,
    },
    {
      title: "Purchase",
      value: 9,
    },
    {
      title: "Revenue",
      value: 10,
    },
  ];

  get timeActive() {
    return this.$store.state.setting.timeActive;
  }

  set timeActive(value: string) {
    this.$store.commit("setting/setTimeActive", value);
  }
  get timezone() {
    return this.$store.state.setting.timezone;
  }

  get from() {
    return this.$store.state.setting.from;
  }

  get to() {
    return this.$store.state.setting.to;
  }

  checkbox = {
    showAll: true,
    domain: true,
    purchaseView: true,
    viewContent: true,
    addToCart: true,
    initiate: true,
    purchase: true,
    revenue: true,
    cost: true,
    profit: true,
    aov: true,
    pcRe: true,
    goCheckout: true,
  };

  disabledButtonDate = false;
  async onFilterByTime(time: string) {
    this.disabledButtonDate = true;
    this.$store.commit("setting/setFilterByTime", { time });
    await this.onGetListStatsDomain();
    this.disabledButtonDate = false;
  }

  mounted() {
    this.onFilterByTime("Today");
  }
  clearFilter() {
    this.config.search = "";
    this.onGetListStatsDomain();
  }

  async onGetListStatsDomain() {
    try {
      this.loadingTable = true;
      const response = await this.$api.stats.statsAnalyticsDomain({
        ...this.config,
        from:
          this.from ||
          getUnixFrom(this.siteInfo.timezone, this.dateRangeText.split("~")[0]),
        to:
          this.to ||
          getUnixTo(this.siteInfo.timezone, this.dateRangeText.split("~")[1]),
        timezone: this.timezone,
      });
      if (response?.data) {
        response.data.forEach((item: any) => {
          item.profit = item.revenue - item.productCost || 0;
          item.aov = item.revenue / item.purchase || 0;
        });
        this.listData = response.data;
        let conversionRate = 0;
        let viewContent = 0;
        let addToCart = 0;
        let initiateCheckout = 0;
        let purchase = 0;
        let revenue = 0;
        let checkout = 0;
        let pcRe = 0;
        let productCost = 0;
        let profit = 0;
        let aov = 0;
        let goCheckout = 0;

        for (let item of this.listData) {
          conversionRate += item.conversionRate;
          viewContent += item.viewContent;
          addToCart += item.addToCart;
          initiateCheckout += item.initiateCheckout;
          purchase += item.purchase;
          revenue += item.revenue;
          checkout += item.checkout;
          pcRe += item["pc/re"];
          productCost += item.productCost;
          profit += item.profit;
          aov += item.aov;
          goCheckout += item.goCheckout;
        }
        conversionRate = conversionRate / response.data.length || 0;
        const totalPcre = this.listData.filter(
          (item: any) => item["pc/re"]
        ).length;

        pcRe = pcRe / totalPcre;

        this.listData.push({
          conversionRate,
          initiateCheckout,
          viewContent,
          addToCart,
          purchase,
          revenue,
          checkout,
          pcRe,
          productCost,
          profit,
          aov,
          goCheckout,
        });
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }
  sortConversionRate = false;
  sortViewContent = false;
  sortAddToCart = false;
  sortInitiateCheckout = false;
  sortPurchase = false;
  sortRevenue = false;
  sortProductCost = false;
  sortProfit = false;
  sortAov = false;
  sortPcre = false;
  sortGoCheckout = false;

  onSortTableLowToHigh(insert: string) {
    const elemLast = this.listData.splice(this.listData.length - 1, 1);
    this.listData = this.$utils.sortList(this.listData, insert, "lowToHigh");
    this.$nextTick(() => {
      this.listData = [...this.listData, ...elemLast];
    });
    this.checkValueSort(insert);
  }

  checkValueSort(insert: string) {
    this.sortGoCheckout = insert === "goCheckout";
    this.sortViewContent = insert === "viewContent";
    this.sortConversionRate = insert === "conversionRate";
    this.sortAddToCart = insert === "addToCart";
    this.sortInitiateCheckout = insert === "initiateCheckout";
    this.sortPurchase = insert === "purchase";
    this.sortRevenue = insert === "revenue";
    this.sortProductCost = insert === "productCost";
    this.sortProfit = insert === "profit";
    this.sortAov = insert === "aov";
    this.sortPcre = insert === "pc/re";
  }

  onSortTableHightToLow(insert: string) {
    const elemLast = this.listData.splice(this.listData.length - 1, 1);
    this.listData = this.$utils.sortList(this.listData, insert, "highToLow");
    this.$nextTick(() => {
      this.listData = [...this.listData, ...elemLast];
    });
    if (insert == "goCheckout") {
      this.sortGoCheckout = false;
    }
    if (insert == "revenue") {
      this.sortRevenue = false;
    }
    if (insert == "viewContent") {
      this.sortViewContent = false;
    }
    if (insert == "conversionRate") {
      this.sortConversionRate = false;
    }
    if (insert == "addToCart") {
      this.sortAddToCart = false;
    }
    if (insert == "initiateCheckout") {
      this.sortInitiateCheckout = false;
    }
    if (insert == "purchase") {
      this.sortPurchase = false;
    }
    if (insert == "productCost") {
      this.sortProductCost = false;
    }
    if (insert == "profit") {
      this.sortProfit = false;
    }
    if (insert == "aov") {
      this.sortAov = false;
    }
    if (insert == "pc/re") {
      this.sortPcre = false;
    }
  }

  get dateDisplay() {
    return this.dateStart + " upto today";
  }

  get siteInfo() {
    return this.$store.state.setting.siteInfo;
  }

  onRefresh() {
    this.onFilterByTime("Today");
  }

  async onGetListStatsDomainFilter() {
    this.$store.commit("setting/setTime", {
      dateStart: this.dateRangeText.split("~")[0],
      dateEnd: this.dateRangeText.split("~")[1],
    });
    this.onGetListStatsDomain();
    this.timeActive = "";
  }

  @Watch("tab")
  changedTab(value: number) {
    if (value === 1) {
      this.onFilterByTime("Today");
    }
  }

  // @Watch("timeActive")
  // changedTimeActive(value: string) {
  //   if (value && this.tab === 1) {
  //     this.onGetListStatsDomain();
  //   }
  // }
  isShowNoCheckbox = false;

  onClickCheckbox(elem?: string) {
    this.isShowNoCheckbox = false;
    if (elem === "showAll" && !this.checkbox.showAll) {
      for (let item in this.checkbox) {
        //@ts-ignore
        this.checkbox[item] = false;
      }
    } else if (elem === "showAll" && this.checkbox.showAll) {
      for (let item in this.checkbox) {
        //@ts-ignore
        this.checkbox[item] = true;
      }
    } else {
      for (let item in this.checkbox) {
        //@ts-ignore
        if (!this.checkbox[item] && elem !== "showAll") {
          this.checkbox.showAll = false;
        }
      }
    }
    if (
      !(
        this.checkbox.addToCart ||
        this.checkbox.aov ||
        this.checkbox.cost ||
        this.checkbox.purchase ||
        this.checkbox.revenue ||
        this.checkbox.domain ||
        this.checkbox.initiate ||
        this.checkbox.pcRe ||
        this.checkbox.profit ||
        this.checkbox.purchaseView ||
        this.checkbox.viewContent ||
        this.checkbox.goCheckout
      )
    ) {
      this.isShowNoCheckbox = true;
    }
  }
}
</script>
